#!/usr/bin/env nix-shell
#!nix-shell -i bash -p curl jq nix-prefetch

cd "$(dirname "${BASH_SOURCE[0]}")"

# kinda hacky? seems to work fine though :3
echo -e "# autogenerated file\n{fetchpatch, fetchurl}: {\n  patches = [" > emoji.nix
curl 'https://api.github.com/repos/glitch-soc/mastodon/pulls/2462/commits' | jq -r 'map(.sha) | .[]' | while read sha; do
	url="https://github.com/glitch-soc/mastodon/pull/2462/commits/$sha.patch"
	hash="$(nix-prefetch fetchpatch --url "$url")"
	echo -e '    (fetchpatch {\n      url = "'$url'";\n      hash = "'$hash'";\n    })' >> emoji.nix
done
echo -e '  ];\n  files = [' >> emoji.nix
curl 'https://api.github.com/repos/glitch-soc/mastodon/pulls/2462/files?per_page=100' | jq -c 'map(select(has("patch")|not) | {name:.filename,url:.raw_url}) | .[]' | while read json; do
	name="$(jq -r '.name' <<<"$json")"
	url="$(jq -r '.url' <<<"$json")"
	hash="$(nix-prefetch fetchurl --url "$url")"
	echo -e '    {\n      src = fetchurl {\n        url = "'$url'";\n        hash = "'$hash'";\n      };\n      name = "'$name'";\n    }' >> emoji.nix
done
echo -e '  ];\n}' >> emoji.nix
